/*
 * Handling the LEDs
 */

 void flashLeds(int reps, int rate) { //short flash to test leds all working; Leds on dPin[] 0 ..7 are connected to +Vcc 
  for (int j = 0; j <= reps; j++) {
    for (int i = 0; i <= 9; i++) {
      digitalWrite(dPin[i], 0);  //Leds on dPin[] 0 ..7 are connected to +Vcc  so this turns em on
    }
    delay(rate);
    for (int i = 0; i <= 9; i++) {
      digitalWrite(dPin[i], 1);  // and off
    }
    delay(rate);
  }
  digitalWrite(dPin[8], 0);  //led on dPin[8] is connected to ground so turn it off now
}

void showLEDs()
{
  //flash LEDs according to corrected average of pings. NOTE: D0 (WHITE) is managed by wifi event hander (see setup();) and D8 is internet failure warning.
  //the lower limit on analogWrite() is 100Hz, but startWaveform() doesn’t have that limit:
  for (int n = 0; n <= 6; n++) {
    int flasher = 8;
    //flash rates chosen to provide easy recognition of status: need to reflect chosen value for pingDelay
    switch (host1[n].tPing) {
      case 0 ... 5: flasher = 40; // VERY fast ping - LED on
        break;
      case 6 ... 17: flasher = 39;
        break;
      case 18 ... 30 : flasher = 37; // fast - medium ping - mostly on
        break;
      case 31 ... 52: flasher = 20; // common ping time range for internet site - 1:1 m -s ratio
        break;
      case 53 ... 95 : flasher = 15; //slow ping - mostly off
        break;
      case 96 ...  180 : flasher = 11;
        break;
      case  181 ... 195 : flasher = 8; //very slow ping, faint flashes
        break;       
      default :   flasher = 0; //led off
    }
    //int startWaveform(uint8_t pin, uint32_t timeHighUS, uint32_t timeLowUS, uint32_t runTimeUS)
    startWaveform(dPin[7 - n], ((40 - flasher) * 10000) + 10, (flasher * 10000) + 10, 0); //using average ping times: 0=LED OFF, 1-39 = flashing, 40=LED ON
  }
}
