
/*
   Do pings & check for internet failure
*/

bool PerformPing()
{
  if (roundComplete)  //ready for next set of pings
  {
    isFinished = false;
    int url = target;
    // send the ping!
    // Ping an IP address a number of times, with specified timeout.
    bool pingOK = pinger.Ping(IPAddress(host1[url].IP), pingNumber, pingDelay);
    roundComplete = false;
  }
  else if (isFinished)        // one set of pings to a single target complete and results in
  {
    isFinished = false;
    //pinger returns pingAvg
    //correct data: average is only correct if no pings lost; otherwise its the sum of the valid ping times
    if (pingsLost == 0) {
      host1[target].tPing = pingAvg;
    }
    else {
      host1[target].tPing = int((pingAvg + pingsLost * pingDelay) / pingNumber); //if all lost tPing = pingAvg + pingDelay
    }
    //*** collecting values for calculating sigma
    //at this point host1[target].tPing holds a corrected value for the average time for one ping.
    t1Ping = host1[target].tPing; // time for a single ping
    t1PingSq = t1Ping * t1Ping;
    host1[target].tSp += t1Ping;
    host1[target].tSpSq += t1PingSq;
    
    host1[target].nLost = pingsLost;
    checkFailedPings();
    roundComplete = true;
  }
  return roundComplete;
}

void checkFailedPings() {
  // check for internet failure - on target 6 Talktalk: test on target 5 NAS box
  if (target == URL) {
    if (pingsLost == 4) webGood = 0; else webGood = 1; //sets sensitivity to line loss. setting of >=2 is too sensitive; trying 4 all pings lost
    if (warnLevel > 0 && pingsLost == 0) warnLevel--; //if internet restarted decrease warnLevel by 1 each minute
    if (warnLevel < 60 && pingsLost > 1) warnLevel += pingsLost * 12; //add 60 minutes to reduce to zero
    if (warnLevel >= 60 && pingsLost > 1) warnLevel += pingsLost * 3; //add a quarter hour
    if (warnLevel >= 240) warnLevel = 240; //dont allow it to exceed a 4 hour period
    if (diagnostic_pings) {
      Serial.print("warnLevel is ");
      Serial.print(warnLevel);
      Serial.print(":  ");
    }
    // logging web fail to file
    if (webGood != webStatus) { //if web available state has changed, log it to file
      logWebState();
      webStatus = webGood;
    }

    if (warnLevel >= warnThreshold) {
      digitalWrite(dPin[8], 1); //put warning LED on
    }
    else if (warnLevel <= warnLowThreshold) {
      digitalWrite(dPin[8], 0);
    }
  }
}
