/*
   Stats and filing
*/

void sumTotals() {
  for (int n = 0; n <= 6; n++) {
    pingLossTotals[n] += host1[n].nLost;
    tPingTotals[n] += host1[n].tPing;
  }
}

void zeroStats() {
  for (int n = 0; n <= 6; n++) {
    pingLossTotals[n] = 0;
    tPingTotals[n] = 0;
    host1[n].tSp = 0;
    host1[n].tSpSq = 0;
  }
  WiFiUp = nRounds; //100% initially, decremented each round if its off
}

void prepStats() {
  //prepare header lines for filing Dont use colons because then date gets separated
  //prepare stats line for filing - about 50 chars.
  //fHeadLine:  Pinging 107.162.133.62 test server
  //fHeadLine1: Date, Time; WiFIStatus%; lost, wait;
  //fStatsLine: 05/09/2021, 09:00:03; 100; 0.00, 1.90;

  //if(diagnostic) Serial.println("prepStats: Stats for filing on SPIFFS:  ");
  fHeadLine = "Pinging ";
  fHeadLine += host1[6].ipString;
  fHeadLine += testServer;
  fHeadLine += "\n";
  fHeadLine1 = "Date, Time; WiFIStatus%; lost, wait, sigma;";
  fHeadLine1 += "\n";
  //prepare total loss values and ping averages - force excel to see as floats
  host1[6].nAvPing = (pingLossTotals[6] / nRounds);
  host1[6].tAvPing = (tPingTotals[6] / nRounds);
  fStatsLine = "";
  fStatsLine += myFormattedDate;
  fStatsLine += "; ";
  //here WiFiUp is just a number; convert to percentage & add to fStatsLine
  WiFiUp = WiFiUp * 100;
  WiFiPercent = WiFiUp / nRounds;
  fStatsLine += WiFiPercent;
  fStatsLine += "; ";
  //add lost & wait to fStatsLine
  fStatsLine += host1[6].nAvPing;  //total lost pings
  fStatsLine += ", ";
  fStatsLine += host1[6].tAvPing;  //average ping time
  fStatsLine += ", ";
  //*** calculate sigma and add to stats line
  float temp = host1[6].tSp;
  temp *= temp;
  temp = temp / nRounds;
  temp = host1[6].tSpSq - temp;
  temp = temp / nRounds;
  sigma = sqrt(temp);
  fStatsLine += sigma;
  fStatsLine += "   ";
  fStatsLine += "\n";
  if(diagnostic){
  //Serial.print(fHeadLine);
  //Serial.print(fHeadLine1);
  Serial.print(fStatsLine);
  }
}

void writeFile() {  //write stats; and header line only if its a new day or first readings
  int bytesWritten;
  String fileName = "/" + sYear + "-" + sMonth + ".txt"; //filename MUST be fully qualified ie have a leading slash.
  File file = SPIFFS.open(fileName, "a"); //"w" to write a file, "a" to append
  if (!file) {
    Serial.println("Error opening file for writing");
    return;
  }
  if (DD != today) { //write headline only if its a new day
    bytesWritten = file.print(fHeadLine);
    bytesWritten = file.print(fHeadLine1);
    today = DD;
  }
  //write stats
  bytesWritten = file.print(fStatsLine);
  delay(10);
  file.close();
}

void logRestart() {  //write restart message to file
  int bytes;
  String fileName = "/" + sYear + "-" + sMonth + ".txt"; //filename MUST be fully qualified ie have a leading slash.
  File file = SPIFFS.open(fileName, "a"); //"w" to write a file, "a" to append
  if (!file) {
    Serial.println("Error opening file for writing");
    return;
  }
  String restart = ""; 
  restart += myFormattedDate;  //match format for fStatsLine
  restart += ";    ;     ,      ; *** netLogger restart - mains failure? ***  ";
  restart += "\n";
  bytes = file.print(restart);
  Serial.print(restart);
  delay(10);
  file.close();
}

void logWebState() {  //write web failure message to file
  int bytes;
  String fileName = "/" + sYear + "-" + sMonth + ".txt"; //filename MUST be fully qualified ie have a leading slash.
  File file = SPIFFS.open(fileName, "a"); //"w" to write a file, "a" to append
  if (!file) {
    Serial.println("Error opening file for writing");
    return;
  }
  String webState = "";
  webState += myFormattedDate;  //match format for fStatsLine
  if (webGood == 0) webState += ";    ;     ,      ; *** web down ***  ";   else webState += ";    ;     ,      ; *** web available ***  ";
  webState += "\n";
  bytes = file.print(webState);
  Serial.print(webState);
  delay(10);
  file.close();
}
