/* 
  NTP TZ DST - bare minimum
  NetWork Time Protocol - Time Zone - Daylight Saving Time
https://werner.rothschopf.net/202011_arduino_esp8266_ntp_en.htm
  Our target for this MINI sketch is:   - get the SNTP request running
  - set the timezone   - (implicit) respect daylight saving time
  - how to "read" time to be printed to Serial.Monitor
  
  This example is a stripped down version of the NTP-TZ-DST (v2)
  And works for ESP8266 core 2.7.4
  by noiasca   2020-09-22
*/
 

void buildStrings(){
  time(&now);                       // read the current time
  localtime_r(&now, &tm);           // update the structure tm with the current time
 
  YYYY = 1900 + tm.tm_year; // timeinfo.tm_year gives years since 1900
  MM = 1 + tm.tm_mon; // timeinfo.tm_mon gives months since january ie 0 - 11;
  DD = tm.tm_mday;
  hh = tm.tm_hour;
  mm = tm.tm_min;
  ss = tm.tm_sec;
  //snprintf(dayStamp, 12, "%02d/%02d/%04d", DD, MM, YYYY);
  snprintf(dayStamp, 12, "%04d/%02d/%02d", YYYY, MM, DD); 
  snprintf(timeStamp, 12, "%02d:%02d:%02d", hh, mm, ss);
  myFormattedDate = String(dayStamp) + ", " +  String(timeStamp);
  //Serial.println(myFormattedDate);
  //sprintf doesnt work because sYear & sMonth are strings not char*
  String tempstring = String(dayStamp);
  sYear = tempstring.substring(0, 4); //extract 4 year characters as string from eg 2020-07-18 to support new file each month: 0 is start of string.
  sMonth = tempstring.substring(5, 7); //extract 2 month characters as string from eg 2020-07-18 to support new file each month:
  // Note: year=dayStamp.substring(nn,mm) fills the year string with characters from position nn (inclusive) to position mm (NOT inclusive)
}
